﻿Global Dim *equippedItem.ACTOR(#equipSlotsMax)
Global Dim itemStackProps(#itemSubtypeMax,#itemClassMax,#itemSortMax)



Procedure readItemConst()
	Define sub, class, sort
	Define i
	
	For sub = 0 To #itemSubtypeMax
		For class = 0 To #itemClassMax
			For sort = 0 To #itemSortMax
				i = 0
				
				If sub = #keyItem									:	i = -1	:	EndIf
				If sub = #consumableItem							:	i = 10	:	EndIf
				If sub = #equipableItem And class = #ammoItem		:	i = 20	:	EndIf
				
				itemStackProps(sub,class,sort) = i
			Next
		Next
	Next
EndProcedure


Procedure rebuildInventory(xFloor,yFloor)
	Define x, y
	Define c, count
	Define sMax
	Define eachCount
	Define countFloorSlots = invSlotStart(#floorInv)
	Dim countItems(#invTypeMax)
	Define invType
	
	resetFloorInvLocation()
	Dim *invPointer(invSlotStart(#floorInv))
	_EachActor(#isItemP,0)
		If actor()\type = #itemActor And actor()\subtype <> #containerItem
			If actor()\invLocation = 0 And xFloor And yFloor And actor()\x = xFloor And actor()\y = yFloor
				actor()\invLocation = countFloorSlots
				invSlotEnd(#floorInv) = countFloorSlots
				countFloorSlots +1
			EndIf
			If actor()\invLocation
				invType = getInventoryIndex(actor()\invLocation)
				If isInvActive(invType)
					countItems(invType) +1
					If ArraySize(*invPointer()) < actor()\invLocation
						ReDim *invPointer(actor()\invLocation)
					EndIf
					*invPointer(actor()\invLocation) = @actor()
					If invType = #floorInv And countFloorSlots > invSlotStart(#floorInv)+80	:	Break : EndIf
				EndIf
			EndIf
		EndIf
	_EndEach()
	slotsMax(#floorInv) = countItems(#floorInv)
	
	ClearList(slot())
	For count = 1 To #invTypeMax
		If isInvActive(count)
			x = 0
			y = 0
			sMax = slotsMax(count)
			If count = #monsterInv	:	sMax = *player\slotsNum : EndIf
			For c = 1 To slotsPerTab(count)
				If count <> #equipInv
					slotX(count,c) = x
					slotY(count,c) = y
				EndIf
				AddElement(slot())
				slot()\index = invSlotStart(count)+((currentTab(count)*slotsPerTab(count))+c)-1
				If (currentTab(count)*slotsPerTab(count))+c > sMax
					slot()\index = 0
				EndIf
				slot()\parentInv = count
				slot()\x = slotX(count,c)
				slot()\y = slotY(count,c)
				x + SpriteWidth(slotSPR(count))
				If x/SpriteWidth(slotSPR(count)) > slotsColumn(count)-1
					x = 0
					y + SpriteHeight(slotSPR(count))
				EndIf
			Next
		EndIf
	Next
EndProcedure


Procedure buildMonsterInventory()
	invOffsetX(#monsterInv) = (#xRes/2)-((SpriteWidth(slotSPR(#monsterInv))*slotsColumn(#monsterInv))/2)
	invOffsetY(#monsterInv) = (#yRes/2)-((SpriteHeight(slotSPR(#monsterInv))*slotsRow(#monsterInv))/2)
	closeX = invOffsetX(#monsterInv)+(slotsColumn(#monsterInv)*SpriteWidth(slotSPR(#monsterInv)))-5
	closeY = invOffsetY(#monsterInv)-SpriteHeight(closeInvSPR(0))+5
	
	invOffsetX(#equipInv) = 10
	invOffsetY(#equipInv) = 10
EndProcedure


Procedure buildFloorInventory(x,y)
	Define count
	Define eachCount
	Define root
	Define row, column

	
	If IsSprite(floorInvSPR)
		FreeSprite(floorInvSPR)
	EndIf
	
	_EachActor(#isItemP,0)
		If actor()\invLocation = 0 And actor()\x = x And actor()\y = y And (Not actor()\subtype = #containerItem)
			count +1
		EndIf
	_EndEach()
	For root = 2 To 9
		If count <= (root*root) Or root = 9
			Break
		EndIf
	Next
	invOffsetX(#floorInv) = (#xRes/2)-((SpriteWidth(slotSPR(#floorInv))*root)/2)
	invOffsetY(#floorInv) = (#yRes/2)-((SpriteHeight(slotSPR(#floorInv))*root)/2)
	slotsPerTab(#floorInv) = root*root
	slotsColumn(#floorInv) = root
	slotsRow(#floorInv) = root
	
	floorInvSPR = CreateSprite(#PB_Any,SpriteWidth(slotSPR(#floorInv))*(root),SpriteHeight(slotSPR(#floorInv))*(root))	
	If IsScreenActive() And StartDrawing(SpriteOutput(floorInvSPR))
		Box(0,0,SpriteWidth(floorInvSPR),SpriteHeight(floorInvSPR),color(#cWood))
		DrawImage(ImageID(floorSlotIMG(4)),0,0)
		DrawImage(ImageID(floorSlotIMG(5)),SpriteWidth(floorInvSPR)-ImageWidth(floorSlotIMG(5)),0)
		DrawImage(ImageID(floorSlotIMG(6)),SpriteWidth(floorInvSPR)-ImageWidth(floorSlotIMG(5)),SpriteHeight(floorInvSPR)-ImageHeight(floorSlotIMG(5)))
		DrawImage(ImageID(floorSlotIMG(7)),0,SpriteHeight(floorInvSPR)-ImageHeight(floorSlotIMG(5)))
		For column = 1 To slotsColumn(#floorInv)
			If column > 1 And column < slotsColumn(#floorInv)
				DrawImage(ImageID(floorSlotIMG(0)),ImageWidth(floorSlotIMG(0))*(column-1),0)
				DrawImage(ImageID(floorSlotIMG(3)),ImageWidth(floorSlotIMG(3))*(column-1),SpriteHeight(floorInvSPR)-ImageHeight(floorSlotIMG(3)))
			EndIf
		Next
		For row = 1 To slotsRow(#floorInv)
			If row > 1 And row < slotsRow(#floorInv)
				DrawImage(ImageID(floorSlotIMG(1)),0,ImageHeight(floorSlotIMG(1))*(row-1))
				DrawImage(ImageID(floorSlotIMG(2)),SpriteWidth(floorInvSPR)-ImageWidth(floorSlotIMG(2)),ImageHeight(floorSlotIMG(2))*(row-1))
			EndIf
		Next
		StopDrawing()
	EndIf
EndProcedure


Procedure openInventory()
	holdLeft = 0
	isInvActive(#monsterInv) = #True
	isInvActive(#equipInv) = #True
	buildMonsterInventory()
	rebuildInventory(0,0)
	processInventory(0,0)
EndProcedure




Procedure processInventory(xFloor,yFloor)
	Define x, y
	Define closeInventory
	Define count
	Define eachCount
	Define isFilled
	Define invClickLeft
	Define invHoldLeft = 1
	Define invClickRight
	Define invHoldRight = 1
	Define selectedSlot, selectedInventory
	Define transferToInv
	Define closeTimer
	Define newTab = currentTab(#monsterInv)
	Define invTabsCurrent = (*player\slotsNum-1)/slotsPerTab(#monsterInv)
	Define doubleClickTimer
	
	ClearList(invTab())
	If isInvActive(#monsterInv)
		If invTabsCurrent > 0
			For count = 0 To invTabsCurrent
				AddElement(invTab())
				invTab()\index = count
				If invTab()\index = newTab
					invTab()\isActive = #True
				EndIf
				invTab()\x = invOffsetX(#monsterInv)+(count*(SpriteWidth(invTabSPR(invTab()\isActive))))+((count+1)*18)
				invTab()\y = invOffsetY(#monsterInv)-SpriteHeight(invTabSPR(invTab()\isActive))
			Next
		EndIf
	EndIf
	*carryItem = #Null
	For count = 1 To #invTypeMax
		If IsSprite(selectedSlotSPR(count,0))
			FreeSprite(selectedSlotSPR(count,0))
		EndIf
		selectedSlotSPR(count,0) = CopySprite(slotSPR(count),#PB_Any)
	Next
	
	Repeat
		If doubleClickTimer And ElapsedMilliseconds()-doubleClickTimer > doubleClickInterval
			doubleClickTimer = 0
		EndIf
		
		*selectedItem = #Null
		selectedInventory = 0
		selectedSlot = 0
		ForEach slot()
			If slot()\index = 0
				Continue
			EndIf
			x = invOffsetX(slot()\parentInv) + slot()\x
			y = invOffsetY(slot()\parentInv) + slot()\y
			If MouseX() >= x And MouseX() < x+SpriteWidth(slotSPR(slot()\parentInv)) And MouseY() >= y And MouseY() < y+SpriteHeight(slotSPR(slot()\parentInv))
				If *invPointer(slot()\index)
					*selectedItem = *invPointer(slot()\index)
					selectedInventory = slot()\parentInv
				EndIf
				selectedSlot = slot()\index
				Break
			EndIf
		Next
		If MouseX() >= closeX And MouseX() <= closeX+SpriteWidth(closeInvSPR(0)) And MouseY() > closeY And MouseY() < closeY+SpriteHeight(closeInvSPR(0))
			*selectedItem = #Null
			selectedSlot = 0
		EndIf
			
		invClickLeft = MouseButton(#PB_MouseButton_Left)
		invClickRight = MouseButton(#PB_MouseButton_Right)
		If invHoldLeft And Not (invClickLeft)
			invHoldLeft = 0
		EndIf
		If invHoldRight And Not (invClickRight)
			invHoldRight = 0
		EndIf
		
		If *selectedItem
			debugActor()
			Select selectedInventory
				Case #floorInv
					transferToInv = #False
					If invClickLeft And (Not invHoldLeft And Not invHoldRight)
						invHoldLeft = 1
						transferToInv = #True
					EndIf
					If invClickRight And (Not invHoldRight And Not invHoldLeft)
						invHoldRight = 1
						transferToInv = #True
					EndIf
					If transferToInv = #True
						If pickupItem(*player,*selectedItem)
							*selectedItem = #Null
							*invPointer(selectedSlot) = #Null
							If Not checkFloorInventory()
								closeTimer = ElapsedMilliseconds()
							EndIf
						EndIf
					EndIf
					
				Case #monsterInv, #equipInv
					;LinksClick
					If invClickLeft And (Not invHoldRight And Not invHoldLeft)
						invHoldLeft = 1
						If *carryItem 
							If *carryItem\invLocation = selectedSlot
								*carryItem = #Null
								switchMouseSprite(cursorSPR)
							Else
								If Not combineItems(*carryItem,*selectedItem)
									switchMouseSprite(actorSPR(*selectedItem\type,*selectedItem\subtype,*selectedItem\class,*selectedItem\sort,*selectedItem\quality,*selectedItem\status,1))
									Swap *selectedItem\invLocation,*carryItem\invLocation
									Swap *selectedItem,*carryItem
									rebuildInventory(0,0)		
								Else
									rebuildInventory(0,0)
								EndIf
							EndIf
						Else
							*carryItem = *selectedItem
							switchMouseSprite(actorSPR(*selectedItem\type,*selectedItem\subtype,*selectedItem\class,*selectedItem\sort,*selectedItem\quality,*selectedItem\status,1))
						EndIf
					EndIf
					;RechtsClick
					If invClickRight And (Not invHoldRight And Not invHoldLeft And Not *carryItem)
						invHoldRight = 1
						invHoldLeft = 1
						If useItem(*selectedItem)
							rebuildInventory(0,0)
						EndIf
					EndIf
			EndSelect
			
		Else
			If (invClickLeft Or invClickRight) And Not invHoldLeft And Not invHoldRight
				If isInvActive(#floorInv)
					If MouseX() < invOffsetX(#floorInv) Or MouseX() > invOffsetX(#floorInv)+SpriteWidth(floorInvSPR) Or MouseY() < invOffsetY(#floorInv) Or MouseY() > invOffsetY(#floorInv)+SpriteHeight(floorInvSPR)
						closeInventory = #True
					EndIf
				EndIf
				If isInvActive(#monsterInv)
					If invClickLeft
						ForEach invTab()
							If MouseX() > invTab()\x And MouseX() < invTab()\x+SpriteWidth(invTabSPR(invTab()\isActive)) And MouseY() > invTab()\y And MouseY() < invTab()\y+SpriteHeight(invTabSPR(invTab()\isActive))
								newTab = invTab()\index
								invHoldLeft = 1
								Break
							EndIf
						Next
						If *carryItem And (Not invHoldLeft)
							If selectedSlot And Not *selectedItem
								invHoldLeft = 1
								*player\inventory[*carryItem\invLocation] = 0
								*carryItem\invLocation = selectedSlot
								*player\inventory[selectedSlot] = #monsterInv
								*carryItem = #Null
								switchMouseSprite(cursorSPR)
								rebuildInventory(0,0)
							EndIf
						EndIf
					EndIf
					If MouseX() > closeX And MouseX() < closeX+SpriteWidth(closeInvSPR(0)) And MouseY() > closeY And MouseY() < closeY+SpriteHeight(closeInvSPR(0))
						invHoldLeft = 1
						invHoldRight = 1						
						closeInventory = #True
					EndIf
					If Not selectedSlot And Not invHoldLeft And Not invHoldRight
						
						If Not *carryItem
							If doubleClickTimer And ElapsedMilliseconds()-doubleClickTimer <= doubleClickInterval
								closeInventory = #True
							Else
								doubleClickTimer = ElapsedMilliseconds()
								invHoldLeft = 1
								invHoldRight = 1
							EndIf
						Else
							If *carryItem And invClickLeft And (Not invHoldLeft)
								invHoldLeft = 1
								dropFromInventory()
							EndIf
						EndIf
						
						
					EndIf
				EndIf
			EndIf
		EndIf
		If *carryItem And invClickRight And (Not invHoldRight)
			invHoldRight = 1
			*carryItem = #Null
			switchMouseSprite(cursorSPR)
		EndIf
		
		If isInvActive(#monsterInv)
			If KeyboardPushed(#PB_Key_1)	:	newTab = 0	:	EndIf
			If KeyboardPushed(#PB_Key_2) And invTabsCurrent > 0	:	newTab = 1	:	EndIf
			If KeyboardPushed(#PB_Key_3) And invTabsCurrent > 1	:	newTab = 2	:	EndIf
			If KeyboardPushed(#PB_Key_4) And invTabsCurrent > 2	:	newTab = 3	:	EndIf
			If KeyboardPushed(#PB_Key_5) And invTabsCurrent > 3	:	newTab = 4	:	EndIf	
			If newTab <> currentTab(#monsterInv)
				currentTab(#monsterInv) = newTab
				rebuildInventory(0,0)
				ForEach invTab()
					invTab()\isActive = #False
					If invTab()\index = newTab
						invTab()\isActive = #True
					EndIf
				Next
			EndIf
			
			If KeyboardReleased(#PB_Key_D) And *selectedItem
				*carryItem = *selectedItem
				dropFromInventory()
			EndIf
		EndIf
		
		
		hideMouse = 1
		_Display()
		hideMouse = 0
		drawInventory()
		drawMouse(255)
		_MyFlip()
		If KeyboardReleased(#PB_Key_I) Or KeyboardReleased(#PB_Key_Escape)
			closeInventory = #True
		EndIf
	Until closeInventory Or cancelSubMenu() Or (closeTimer And ElapsedMilliseconds()-closeTimer > 333)
	
	_EachActor(#isItemP,0)
		actor()\frame = 0
	_EndEach()
	For count = 1 To #invTypeMax
		isInvActive(count) = #False
	Next
	switchMouseSprite(cursorSPR)
	;slotLocation für floorInventory wieder herstellen!!!
	resetFloorInvLocation()
	holdLeft = 1
	holdRight = 1
EndProcedure


Procedure dropFromInventory()
	dropItem(*carryItem,*player\x,*player\y)
	*carryItem = #Null
	switchMouseSprite(cursorSPR)
	rebuildInventory(0,0)
	checkItemEffects()
EndProcedure



Procedure combineItems(*firstItem.ACTOR,*secondItem.ACTOR)
	Define numStacks
	
	;*firstItem = *carryItem
	
	;Stacks aufaddieren
	If compareActor(*firstItem,*secondItem) And itemStackProps(*firstItem\subtype,*firstItem\class,*firstItem\sort)
		While *secondItem\stacks < itemStackProps(*secondItem\subtype,*secondItem\class,*secondItem\sort) And *firstItem\stacks-numStacks > 0
			*secondItem\stacks +1
			numStacks +1
		Wend
	EndIf
	
	;Karte zusammensetzen
	If *firstItem\subtype = #staticItem And *secondItem\subtype = #staticItem And *firstItem\class = #mapItem And *secondItem\class = #mapItem
		If (*firstItem\sort = 1 Or *firstItem\sort = 2) And (*secondItem\sort = 1 Or *secondItem\sort = 2) And *firstItem\property[#propFloorIndex] = *secondItem\property[#propFloorIndex]
			*secondItem\sort = 0
			numStacks = 1
		EndIf
	EndIf
	
	If numStacks
		deleteFromInventory(numStacks,*firstItem)
	EndIf
	
	checkItemEffects()
	
	ProcedureReturn numStacks
EndProcedure



Procedure useItem(*thisItem.ACTOR)
	Define success
	
	If *thisItem\subtype = #staticItem And *thisItem\class = #mapItem And *thisItem\sort = 0
		If *thisItem\property[#propFloorIndex] = dFloor
			MouseLocate(#xRes/2,#yRes/2)
			openMap()
			success = #True
		Else
			Debug "Wrong Floor"
		EndIf
	EndIf
	If *thisItem\subtype = #consumableItem
		deleteFromInventory(1,*thisItem)
		success = #True
	EndIf
	
	ProcedureReturn success
EndProcedure



Procedure deleteFromInventory(numStacks,*thisItem.ACTOR)
	*thisItem\stacks -numStacks
	updateStacks(0,0)
	*carryItem = #Null
	switchMouseSprite(cursorSPR)
EndProcedure



Procedure checkFloorInventory()
	Define count
	Define isFilled
	
	For count = invSlotStart(#floorInv) To invSlotEnd(#floorInv)
		If *invPointer(count)
			isFilled +1
		EndIf
	Next
	
	ProcedureReturn isFilled
EndProcedure




Procedure resetFloorInvLocation()
	Define eachCount
	
	_EachActor(#isItemP,0)
		If actor()\invLocation >= invSlotStart(#floorInv)
			actor()\invLocation = 0
		EndIf
	_EndEach()
EndProcedure



Procedure createItem(sub,class,sort,quality,status,depth,interact,x,y)
	Dim propertyTemp(#propertyMax)
	
	actorFactory(#True,#True,#False,#False,#False,#False,#False,#True,#False,#False,#False,#False,#False,
	             0,#itemActor,sub,class,sort,quality,status,depth,1,#nullCollision,#False,#False,interact,x,y,-1)
	
	
	Select sub
		Case #containerItem
			actorToItem(1,-1)
		Case #consumableItem		;Apfel
			actorToItem(Random(3,2),-1)
		Case #equipableItem
			If class = #ammoItem
				actorToItem(Random(5,3),-1) ;Pfeile
			Else
				actorToItem(1,100) ;Andere Waffen
			EndIf
		Case #keyItem
			actorToItem(1,-1)	 ;Schlüssel
		Case #staticItem
			propertyTemp(#propFloorIndex) = dFloor
			actorToItem(1,-1)
	EndSelect
EndProcedure


Procedure actorToItem(stacks,durability)
	Define count
	
	actor()\stacks = stacks
	actor()\durability = durability
	For count = 0 To #propertyMax
		actor()\property[count] = propertyTemp(count)
	Next
EndProcedure


Procedure pickupItem(*character.ACTOR,*item.ACTOR)
	Define *slotItem.ACTOR = #Null
	Define nextSlot
	Define eachCount
	
	Repeat
		nextSlot = getFreeSlotIndex(*character,*item)	;den nächsten gültigen Slot-Index heraussuchen
		If nextSlot
			If *character\inventory[nextSlot] = 0				;falls Slot leer ...
				*character\inventory[nextSlot] = #monsterInv	;Slot belegen
				copyActor(*item,#True)							;Item kopieren und als inventoryElement initialisieren
				actor()\x = 0
				actor()\y = 0
				actor()\visible = #nullVisibility
				actor()\index = *character\index
				actor()\invLocation = nextSlot
				actor()\stacks = 1	;1 Stack vorbelegen
				*item\stacks -1							;aufzuhebendes Item um 1 Stack reduzieren
				*slotItem = @actor()					;Adresse des slotItems merken
			Else										;falls Slot gültig, aber belegt (stackable Item!) ...
				_EachActor(#isChildP,0)
					If actor()\type = #itemActor And actor()\index = *character\index		;... Adresse des slotItems, welches noch Kapazität hat, heraussuchen ...
						If actor()\invLocation = nextSlot
							*slotItem = @actor()			 ;... und merken
							Break
						EndIf
					EndIf
				_EndEach()
			EndIf
			
			;Stacks transferieren, bis maximale Stacks erreicht oder keine Stacks übrig ...
			;(stackable = -1) = unendlich viele Stacks erlaubt
			While *item\stacks > 0 And (*slotItem\stacks < itemStackProps(*slotItem\subtype,*slotItem\class,*slotItem\sort) Or
					itemStackProps(*slotItem\subtype,*slotItem\class,*slotItem\sort) = -1)	
				*item\stacks -1
				*slotItem\stacks +1
			Wend
		EndIf
	Until (Not nextSlot) Or *item\stacks = 0  ;ggf. nächsten gültigen Slot suchen (stackables)

	
	If *slotItem	:	updateStacks(*item\x,*item\y)	:	EndIf
	If *character = *player	:	checkItemEffects()	:	EndIf
	
	ChangeCurrentElement(actor(),*item)   	;aktuelle actor()-Adresse wiederherstellen!
	ProcedureReturn *slotItem				;Pickup erfolgreich?
EndProcedure


Procedure updateStacks(x,y)
	Define eachCount, parentLoop
	Define count
	Define *firstItem.ACTOR = #Null
	Define *container.ACTOR = #Null
	Define *currentItem.ACTOR
	
	_EachActor(#isItemP,0)
		If actor()\stacks = 0
			parentLoop = eachCount
			*currentItem = @actor()
			If actor()\index
				_EachActor(#isMonsterP,0)
					If actor()\index = *currentItem\index
						actor()\inventory[*currentItem\invLocation] = 0
						Break
					EndIf
				_EndEach()
				*currentItem\invLocation = 0
			EndIf
			markForKill(*currentItem)
			eachCount = parentLoop
		EndIf
	_EndEach()
	
	;ContainerCheck
	If x And y
		_EachActor(#isItemP,0)
			If actor()\x = x And actor()\y = y
				If actor()\subtype = #containerItem
					*container = @actor()
				Else
					If count = 0
						*firstItem = @actor()
					EndIf
					count +1
					If count > 1
						If count = 2
							*firstItem\visible = #nullVisibility
							*firstItem\interaction = #nullInteract
							switchActorIdentity(*firstItem,#canInteractP,#False)
						EndIf
						actor()\visible = #nullVisibility
						actor()\interaction = #nullInteract
						switchActorIdentity(@actor(),#canInteractP,#False)
					EndIf
				EndIf
			EndIf
		_EndEach()
		
		If count < 2
			If *container
				markForKill(*container)
			EndIf
			If *firstItem
				*firstItem\visible = #defaultVisibility
				*firstItem\interaction = #selfInteract
				switchActorIdentity(*firstItem,#canInteractP,#True)
			EndIf
		EndIf
		If count > 1 And Not *container
			createItem(#containerItem,#lootCont,0,0,0,#containerDepth,#selfInteract,x,y)
		EndIf
	EndIf
	
	If *player
		*player\ableRanged = checkCanRanged()
	EndIf
EndProcedure


Procedure dropItem(*itemToDrop.ACTOR,x,y)
	Define eachCount
	If *itemToDrop\invLocation
		_EachActor(#isMonsterP,0)
			If actor()\index = *itemToDrop\index
				actor()\inventory[*itemToDrop\invLocation] = 0
				Break
			EndIf
		_EndEach()
	EndIf
	*itemToDrop\invLocation = 0
	*itemToDrop\x = x
	*itemToDrop\y = y
	*itemToDrop\index = 0
	switchActorIdentity(*itemToDrop,#isChildP,#False)
	
	If itemStackProps(*itemToDrop\subtype,*itemToDrop\class,*itemToDrop\sort)
		_EachActor(#isItemP,0)
			If actor() <> *itemToDrop And actor()\x = x And actor()\y = y And compareActor(*itemToDrop,@actor())
				*itemToDrop\stacks + actor()\stacks
				actor()\stacks = 0
			EndIf
		_EndEach()
	EndIf
	
	updateStacks(x,y)
EndProcedure


Procedure getFreeSlotIndex(*character.ACTOR,*item.ACTOR)
	Define count
	Define eachCount
	
	If *character\slotsNum > 0
		If itemStackProps(*item\subtype,*item\class,*item\sort)
			_EachActor(#isChildP,0)
				If actor()\type = #itemActor And actor()\index = *character\index ;And actor()\invLocation >= invSlotStart(#monsterInv) And actor()\invLocation <= (invSlotStart(#monsterInv)+(*character\slotsNum-1))
					If compareActor(@actor(),*item)
						If actor()\stacks < itemStackProps(actor()\subtype,actor()\class,actor()\sort) Or itemStackProps(actor()\subtype,actor()\class,actor()\sort) = -1
							ProcedureReturn actor()\invLocation
						EndIf
					EndIf
				EndIf
			_EndEach()
		EndIf
		For count = invSlotStart(#monsterInv) To (invSlotStart(#monsterInv)+(*character\slotsNum-1))
			If *character\inventory[count] = 0
				ProcedureReturn count
			EndIf
		Next
	EndIf
	
	ProcedureReturn #False
EndProcedure


Procedure compareActor(*source.ACTOR,*compare.ACTOR)
	If *source = *compare
		Debug "sourceActor = compareActor"
		End
	EndIf
	If *source\type = *compare\type And *source\subtype = *compare\subtype And *source\class = *compare\class And *source\sort = *compare\sort And *source\quality = *compare\quality And *source\status = *compare\status
		ProcedureReturn #True
	EndIf
EndProcedure


Procedure getInventoryIndex(slotLoc)
	Define count
	
	For count = 1 To #invTypeMax
		If slotLoc >= invSlotStart(count)+(slotsPerTab(count)*currentTab(count)) And slotLoc <= invSlotStart(count)+((slotsPerTab(count)*(currentTab(count)+1))-1) And slotLoc <= invSlotEnd(count)
			ProcedureReturn count
		EndIf
	Next
EndProcedure



Procedure checkItemEffects()
	Define eachCount
	
	hasMap = 0
	
	_EachActor(#isItemP,#Null)
		If actor()\index = *player\index
			If actor()\subtype = #staticItem And actor()\class = #mapItem And (actor()\property[#propFloorIndex] = dFloor)
				hasMap +1
				If actor()\sort = 0
					hasMap = 2
					Break
				EndIf
			EndIf
		EndIf
	_EndEach()
EndProcedure



Procedure copyActor(*source.ACTOR,isChild)
	Define count
	Define hasProperty
		
	
	actorFactory(*source\ident[#hasImageP],*source\ident[#canInteractP],*source\ident[#isDoorP],*source\ident[#canMoveP],*source\ident[#isAnimationP],*source\ident[#isTempAnimationP],
					*source\ident[#isMonsterP],*source\ident[#isItemP],isChild,*source\ident[#isEffectP],*source\ident[#isTriggerP],*source\ident[#isDimensionP],*source\ident[#isGadgetP],
					*source\index,*source\type,*source\subtype,*source\class,*source\sort,*source\quality,*source\status,*source\drawPriority,
					*source\visible,*source\collision,*source\blockShoot,*source\blockLoS,*source\interaction,*source\x,*source\y,*source\hp)
	
	actor()\xMicro = *source\xMicro
	actor()\yMicro = *source\yMicro
	
	If *source\ident[#isItemP]
		For count = 0 To #propertyMax
			propertyTemp(count) = *source\property[count]
		Next
		actorToItem(*source\stacks,*source\durability)
	EndIf
EndProcedure


Procedure openMap()
	Define xSpriteOffset = (#xRes/2)-(SpriteWidth(mapSPR)/2)
	Define ySpriteOffset = (#yRes/2)-(SpriteHeight(mapSPR)/2)
	Define xOffset = xSpriteOffset + 173
	Define yOffset = ySpriteOffset + 50
	Define xSpace = ImageWidth(asciiIMG(0))
	Define ySpace = ImageHeight(asciiIMG(0))
	Define viewMapX = 14
	Define viewMapY = 15
	Define xMapCenter = limit(*player\x,viewMapX,xMax-viewMapX)
	Define yMapCenter = limit(*player\y,viewMapY,yMax-viewMapY)
	Define xMapCenterNew = xMapCenter
	Define yMapCenterNew = yMapCenter
	Define mapOffsetX, mapOffsetY
	Define blinkPlayer = 1
	Define blinkPlayerTimer = ElapsedMilliseconds()
	Define xPanStep, yPanStep
	Define exitMap
	Define panTimer
	
	updateMapView(xMapCenter,yMapCenter,viewMapX,viewMapY)
	Repeat
		If ElapsedMilliseconds()-panTimer > 10
			xPanStep = 0
			yPanStep = 0
			If KeyboardPushed(#PB_Key_A)	:	xPanStep-1	: EndIf
			If KeyboardPushed(#PB_Key_D)	:	xPanStep+1	: EndIf
			If KeyboardPushed(#PB_Key_W)	:	yPanStep-1	: EndIf
			If KeyboardPushed(#PB_Key_S)	:	yPanStep+1	: EndIf
			If KeyboardPushed(#PB_Key_C)
				xMapCenterNew = limit(*player\x,viewMapX,xMax-viewMapX)
				yMapCenterNew = limit(*player\y,viewMapY,yMax-viewMapY)
			EndIf
			If xPanStep	:	xMapCenterNew = limit(xMapCenterNew+xPanStep,viewMapX,xMax-viewMapX) : EndIf
			If yPanStep	:	yMapCenterNew = limit(yMapCenterNew+yPanStep,viewMapY,yMax-viewMapY) : EndIf
			If xMapCenterNew <> xMapCenter Or yMapCenterNew <> yMapCenter
				xMapCenter = xMapCenterNew
				yMapCenter = yMapCenterNew
				updateMapView(xMapCenter,yMapCenter,viewMapX,viewMapY)
				panTimer = ElapsedMilliseconds()
			EndIf
		EndIf
		
		If KeyboardReleased(#PB_Key_Escape)	:	exitMap = #True : EndIf
		If MouseButton(#PB_MouseButton_Left) Or MouseButton(#PB_MouseButton_Right)
			If MouseX() < xOffset Or MouseX() > xOffset + SpriteWidth(mapOverlaySPR) Or MouseY() < yOffset Or MouseY() > yOffset + SpriteHeight(mapOverlaySPR)
				exitMap = #True
			EndIf
		EndIf

		
		
		
		If ElapsedMilliseconds()-blinkPlayerTimer >= 125
			Select blinkPlayer
				Case 0	:	blinkPlayer = 1
				Case 1	:	blinkPlayer = 0
			EndSelect
			blinkPlayerTimer = ElapsedMilliseconds()
		EndIf
		
		hideMouse = 1
		_Display()
		hideMouse = 0
		DisplayTransparentSprite(mapSPR,xSpriteOffset,ySpriteOffset)		
		DisplayTransparentSprite(mapOverlaySPR,xOffset,yOffset)
		mapOffsetX = limit(xMapCenter-viewMapX,0,xMax)
		mapOffsetY = limit(yMapCenter-viewMapY,0,yMax)
		If xMapCenter-viewMapX <= *player\x And xMapCenter+viewMapX >= *player\x And yMapCenter-viewMapY <= *player\y And yMapCenter+viewMapY >= *player\y
			If blinkPlayer
				DisplaySprite(asciiPlayerSPR,(xOffset+(*player\x-mapOffsetX)*xSpace),yOffset+((*player\y-mapOffsetY)*ySpace))
			EndIf
		EndIf			
		
		
		drawMouse(255)
		
		If screen
			WaitWindowEvent(1)
		EndIf		
		_MyFlip()
	Until cancelSubMenu() Or exitMap
EndProcedure



DataSection
label_slotData:
	Data.i #slotsMaxConst,5,7	;InventorySlots
	Data.i 10,12				;ItemOFfset
	
	Data.i #equipSlotsMax,0,0		;EquipmentSlots
	Data.i 10,12
	Data.i #equipSlotsMax			;if slotsPerTab(Count) = 0 ... read.i
	Data.i 0,0
	Data.i 74,0
	Data.i 148,0
	Data.i 0,70
	Data.i 74,70
	Data.i 148,70
	Data.i 0,70*2
	Data.i 74,70*2
	Data.i 148,70*2
	Data.i 0,70*3
	Data.i 74,70*3
	Data.i 148,70*3
	Data.i 74,70*4
	
	Data.i 0,9,9				;floorSlots
	Data.i 10,12
EndDataSection

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 199
; FirstLine = 184
; Folding = ----
; EnableXP