﻿


Procedure limit(var,min,max)
	If var < min
		ProcedureReturn min
	Else
		If var > max
			ProcedureReturn max
		Else
			ProcedureReturn var
		EndIf
	EndIf
EndProcedure


Procedure.f limitFloat(var.f,min.f,max.f)
	If var < min
		ProcedureReturn min
	Else
		If var > max
			ProcedureReturn max
		Else
			ProcedureReturn var
		EndIf
	EndIf
EndProcedure




Procedure getPath(x0,y0,xTarget,yTarget,*pathPointer.ACTOR,recordPath)
	#costStraight = 10
	#costDiagonal = 14		;Quadratwurzel 2
	
	ClearList(node())
	
	Dim checkList(xMax,yMax)	;Schnelles Schreiben in die Open-List (= 1) und die Closed-List (-1)
	Dim g_cost(xMax,yMax)	;G-Kosten = bekannte Pfadkosten-Summe zum aktuellen Tile
	Dim h_cost(xMax,yMax)	;H-Kosten = Geschätzte verbleibende Entfernung vom bekannten Tile aus (Luftlinie)
	Dim f_cost(xMax,yMax)	;F-Kosten = G + H
	
	Dim parentX(xMax,yMax)	;Parent-Nodes speichern ...
	Dim parentY(xMax,yMax)	;... damit gefundener Pfad abgerufen werden kann
	
	Dim collide(1)
	Define firstNode
	Define lowF
	Define nodeCost
	Define x, y
	Define dir, cornerDir
	Define tileOkay
	Define *nodePointer.POINT_XY ;Pointer auf Speicheradresse der aktuellen Node
	Define actorCollision = 1

	Define count	;Zählt Schritte von Start zum Ziel (0 = kein Pfad existiert, -1 = Start und Zielort identisch)
	aStarX = 0
	aStarY = 0
	
	If *pathPointer <> #Null
		actorCollision = *pathPointer\collision
	EndIf
		
	
	
	If x0 = xTarget And y0 = yTarget
		;Debug "Origin and Target-Node are identical!"
		ProcedureReturn -1 ;Start und Zielfeld sind dasselbe
	Else
		collide(0) = collisionMap(x0,y0)
		collide(1) = collisionMap(xTarget,yTarget)
		collisionMap(x0,y0) = 0
		collisionMap(xTarget,yTarget) = 0

		;Add first Node to Open List
		checkList(xTarget,yTarget) = 1
		AddElement(node())
		node()\X = xTarget					;Pfad wird rückwärts gesucht ...
		node()\Y = yTarget					;... Aufzeichnen erfolgt am Ende mittels Rückverfolgung der Parent-Nodes
		;erstes Element hat keinen Parent
		
		;optionale G-Penalities für bestimmte Felder festlegen
		;Beispiel: g_cost(lavaX,lavaY) = 1000
		Repeat
			;find Low F
			firstNode = FirstElement(node())
			If firstNode = #Null
				collisionMap(x0,y0) = collide(0)
				collisionMap(xTarget,yTarget) = collide(1)
				ProcedureReturn 0
				;optionale Konsequenz aufrufen, wenn kein Pfad gefunden wurde
			Else
				lowF = f_cost(node()\X,node()\Y)
				*nodePointer = @node()
				ForEach node()
					If f_cost(node()\X,node()\Y) < lowF				
						lowF = f_cost(node()\X,node()\Y)
						*nodePointer = @node()
					EndIf
				Next
			EndIf
			
			;Angrenzende Felder überprüfen
			If checkList(*nodePointer\x,*nodePointer\y) = 1
				checkList(*nodePointer\x,*nodePointer\y) = -1
				
				For dir = 1 To 8
					
					x = limit(*nodePointer\x+xMod(dir),0,xMax)
					y = limit(*nodePointer\y+yMod(dir),0,yMax)

					
					If (x = *nodePointer\x And y = *nodePointer\y) Or collisionMap(x,y) >= actorCollision Or checkList(x,y) = -1
						Continue ;Parent-Nodes, blockierte- und ClosedList-Tiles direkt überspringen = Speed!
					EndIf
					
					tileOkay = 1
					;{ NO CORNER CUTS
					If x <> *nodePointer\x And y <> *nodePointer\y
						
						For cornerDir = 5 To 8
							If *nodePointer\x+xMod(cornerDir) = x And *nodePointer\y+yMod(cornerDir) = y
								If collisionMap(*nodePointer\x+xMod(cornerDir)+xSide(cornerDir,1),*nodePointer\y+yMod(cornerDir)+ySide(cornerDir,1)) >= actorCollision XOr
										collisionMap(*nodePointer\x+xMod(cornerDir)+xSide(cornerDir,2),*nodePointer\y+yMod(cornerDir)+ySide(cornerDir,2)) >= actorCollision
									tileOkay = 0
								EndIf
							EndIf
						Next
					EndIf
					;}
					
					If tileOkay
						If x = x0 And y = y0 ;Wenn Ziel erreicht wurde ...
							parentX(x,y) = *nodePointer\x
							parentY(x,y) = *nodePointer\y
							Goto label_pathFound	;... Routine verlassen und Pfad aufzeichnen
						EndIf
						If checkList(x,y) = 1
							;checken, ob der Weg zum bereits bekannten Feld über den neuen Pfad kürzer ist.
							;Wenn ja, dann Parent-Koordinaten des bekannten Feldes "umleiten".
							nodeCost = #costStraight
							If (x <> *nodePointer\x And y <> *nodePointer\y)
								nodeCost = #costDiagonal
							EndIf
							If (g_cost(*nodePointer\x,*nodePointer\y) + nodeCost) < g_cost(x,y)
								g_cost(x,y) = g_cost(*nodePointer\x,*nodePointer\y) + nodeCost
								f_cost(x,y) = g_cost(x,y) + h_cost(x,y)
								parentX(x,y) = *nodePointer\x
								parentY(x,y) = *nodePointer\y
							EndIf
						EndIf
						If checkList(x,y) = 0
							;Add to Open List
							checkList(x,y) = 1
							AddElement(node())
							node()\X = x
							node()\Y = y
							parentX(x,y) = *nodePointer\x
							parentY(x,y) = *nodePointer\y
							nodeCost = #costStraight
							If x <> *nodePointer\x And y <> *nodePointer\y
								nodeCost = #costDiagonal
							EndIf
							g_cost(x,y) + g_cost(*nodePointer\x,*nodePointer\y) + nodeCost
							h_cost(x,y) = (Abs(x-x0) + Abs(y-y0)) * #costStraight			;Annäherung statt Satz des Pythagoras = ausreichend, da nur Längenvergleich stattfindet
							f_cost(x,y) = g_cost(x,y) + h_cost(x,y)
						EndIf
					EndIf
						

				Next

				ChangeCurrentElement(node(), *nodePointer)	;auf aktuelles Listenelement zurückschalten damit richtiges Element
				DeleteElement(node())						;gelöscht wird (falls in der Zwischenzeit AddElement() aufgerufen wurde)

			EndIf
			
		ForEver			
	EndIf
	
	
	
	
label_pathFound:		;Pfad aufzeichnen und ...

	aStarX = parentX(x0,y0)
	aStarY = parentY(x0,y0)
	collisionMap(x0,y0) = collide(0)
	collisionMap(xTarget,yTarget) = collide(1)
	If Not recordPath
		ProcedureReturn 1
	EndIf
	
	ClearList(aStarPath())
	count = 1
	AddElement(aStarPath())
	aStarPath()\x = x0
	aStarPath()\y = y0
	*nodePointer = @aStarPath()
	
	Repeat
		count +1
		AddElement(aStarPath())
		aStarPath()\x = parentX(*nodePointer\x,*nodePointer\y)
		aStarPath()\y = parentY(*nodePointer\x,*nodePointer\y)
		*nodePointer = @aStarPath()
	Until aStarPath()\x = xTarget And aStarPath()\y = yTarget
	
	ProcedureReturn count ;... Schrittanzahl an Requester zurückgeben
EndProcedure



Procedure getBresenham(x,y,xTarget,yTarget,updateBresenMap)
	Define dX,dY		;Pixel
	Define dXabs,dYabs 	;Absolut-Distanzen
	Define dXsgn,dYsgn 	;Signum-Distanzen
	Define pdX,pdY 		;Parallel-Schritt
	Define ddX,ddY 		;Diagonal-Schritt
	Define eFast,eSlow  ;Fehlerschritte, schnell, langsam
	Define error
	Define i

	dX = xTarget - x ;Target-Koordinaten
	dY = yTarget - y
	dXabs = Abs(dX)
	dYabs = Abs(dY)
	dXsgn = Sign(dX)
	dYsgn = Sign(dY)
				
	If dXabs > dYabs ; x = schnelle Richtung
		pdX = dXsgn
		pdY = 0
		ddX = dXsgn
		ddY = dYsgn
		eFast = dYabs
		eSlow = dXabs
	Else
		pdX = 0
		pdY = dYsgn
		ddX = dXsgn
		ddY = dYsgn
		eFast = dXabs
		eSlow = dYabs
	EndIf
			
	error = eSlow/2

	For i = 1 To eSlow
		error = error - eFast
		If error < 0
			error = error + eSlow
			x = x + ddX
			y = y + ddY
		Else
			x = x + pdX
			y = y + pdY
		EndIf
		
		If updateBresenMap
			bresenMap(x,y) = #True
			_Dist(*player\x,*player\y,x,y)
			If distance <= radiance
				exploreMap(x,y) = #True
			EndIf
		EndIf
		If bresenRef(x,y)
			ProcedureReturn 0
		EndIf
	Next
	ProcedureReturn 1
EndProcedure




Procedure createScreen(x,y,depth,exeName.s)
	Define window

    If Not InitSprite() : Debug "InitSprite() failed" : End : EndIf
   
    If depth = 0
    	window = OpenWindow(#PB_Any,0,0,x,y,exeName,#PB_Window_ScreenCentered | #PB_Window_SystemMenu)
        If Not window : Debug "Window-Creation failed" : End : EndIf
        If Not OpenWindowedScreen(WindowID(window),0,0,x,y) : Debug "Screen-Creation failed" : End : EndIf
    Else
    	ExamineDesktops()
    	If Not OpenScreen(x,y,depth,exeName,#PB_Screen_WaitSynchronization,DesktopFrequency(0)) : Debug "Fullscreen failed" : End : EndIf
    EndIf
    
    If Not InitMouse() : Debug "InitMouse() failed" : End : EndIf
    If Not InitKeyboard() : Debug "InitKeyboard() failed" : End : EndIf
    UsePNGImageDecoder()
     
    ProcedureReturn window
EndProcedure



Procedure weightedRoll(n1,n2,n3,n4,n5,n6,n7,n8,n9,n10)
  Define nMax
  Define nDice
  Define nAdd
  Dim chance(10)
  Define a
  
  chance(1) = n1
  chance(2) = n2
  chance(3) = n3
  chance(4) = n4
  chance(5) = n5
  chance(6) = n6
  chance(7) = n7
  chance(8) = n8
  chance(9) = n9
  chance(10) = n10
  
  For a = 1 To 10
    nMax = nMax + chance(a)
  Next
  nDice = Random(nMax,1)
  
  For a = 1 To 10
    nAdd = nAdd + chance(a)
    If nAdd >= nDice
      ProcedureReturn a
    EndIf
  Next
EndProcedure


Procedure giveGauss(value)
	ProcedureReturn (value+1)*(value*0.5)
EndProcedure


Procedure gaussRoll(minValue,maxValue,ceilWeight)
	Define newMax
	Define add		
	Define sum
	Define dice
	Define a
	Define n
	
	newMax = (maxValue-minValue)+1
	sum = (newMax+1)*(newMax*0.5)
	dice = Random(sum,1)
	For a = 0 To newMax
		add = add+a
		If add >= dice
			If ceilWeight
				ProcedureReturn (a + minValue)-1
			Else
				If Not ceilWeight 
					ProcedureReturn ((newMax-(a-1))+minValue)-1	;return low values
				EndIf
			EndIf
		EndIf
	Next
EndProcedure



Procedure trueRand(min,max)
	Define dice
	Define rolls
	Define a

	;If current mouse coordinates and/or MilliSecs() equate an odd number,
	;add bonus rolls in between, in order to shift the random number queue
	If MouseX() % 2 <> 0
		rolls = rolls +1 ;
	EndIf
	If MouseY() % 2 <> 0
		rolls = rolls +2
	EndIf
	If ElapsedMilliseconds() % 2 <> 0
		rolls = rolls +4
	EndIf

	For a = 0 To rolls
		dice = Random(max,min)
	Next
	
	ProcedureReturn dice ;return the desired number
EndProcedure


Procedure refreshDijkstraList()
	Dim iniDijkstra(xMax,yMax)
	ClearList(finalDijkstra())
	ForEach freeField()
		If collisionMap(freeField()\x,freeField()\y) < #pathCollision
			AddElement(finalDijkstra())
			finalDijkstra()\x = freeField()\x
			finalDijkstra()\y = freeField()\y
			iniDijkstra(finalDijkstra()\x,finalDijkstra()\y) = highDijkstra
		EndIf
	Next
EndProcedure


Procedure createSearchDijkstra()
	;	DisableDebugger
	Define eachCount
	Define dir
	Define *current.ACTOR = @actor()
	Define noChange, noChangeTemp
	
	CopyList(finalDijkstra(),dijkstra())
	CopyArray(iniDijkstra(),searchDijkstra())
	_EachActor(#isMonsterP,0)
		If actor()\xSearch Or actor()\ySearch
			searchDijkstra(actor()\xSearch,actor()\ySearch) = 1
		EndIf
	_EndEach()
	ForEach dijkstra()
		If dijkstra()\x < *player\x-50 Or dijkstra()\x > *player\x+50 Or dijkstra()\y < *player\y-50 Or dijkstra()\y > *player\y+50
			DeleteElement(dijkstra())
		EndIf
	Next	
	
	Repeat
		noChange = #True
		ForEach dijkstra()
			noChangeTemp = #True
	
			For dir = 1 To 8
				If collisionMap(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) >= #pathCollision
					Continue
				Else
					If searchDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) < (searchDijkstra(dijkstra()\x,dijkstra()\y) -10) 
						searchDijkstra(dijkstra()\x,dijkstra()\y) = searchDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) +10
						noChange = #False
						noChangeTemp = #False
					EndIf
				EndIf
			Next
			If noChangeTemp And searchDijkstra(dijkstra()\x,dijkstra()\y) <> highDijkstra
				DeleteElement(dijkstra())
			EndIf
		Next
	Until noChange
	
	ChangeCurrentElement(actor(),*current)
;	EnableDebugger
EndProcedure


Procedure calculateDijkstra()
;	DisableDebugger
	Define x, y
	Define dir
	Define noChange, noChangeTemp
	Define count
	Define *dijkstraPointer.POINT_XY
	
	CopyList(finalDijkstra(),tempDijkstra())
	ForEach tempDijkstra()
		If tempDijkstra()\x < *player\x-15 Or tempDijkstra()\x > *player\x+15 Or tempDijkstra()\y < *player\y-15 Or tempDijkstra()\y > *player\y+15
			DeleteElement(tempDijkstra())
		EndIf
	Next
	
	CopyList(tempDijkstra(),dijkstra())	
	CopyArray(iniDijkstra(),playerDijkstra())
	playerDijkstra(*player\x,*player\y) = 1
	Repeat
		noChange = #True
		ForEach dijkstra()
			noChangeTemp = #True
			For dir = 1 To 8
				If collisionMap(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) >= #pathCollision
					Continue
				Else
					If playerDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) < (playerDijkstra(dijkstra()\x,dijkstra()\y) -10)
						playerDijkstra(dijkstra()\x,dijkstra()\y) = playerDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) +10
						noChange = #False
						noChangeTemp = #False
					EndIf
				EndIf
				
			Next
			If noChangeTemp And playerDijkstra(dijkstra()\x,dijkstra()\y) <> highDijkstra
				DeleteElement(dijkstra())
			EndIf
		Next
	Until noChange
	

	CopyList(tempDijkstra(),dijkstra())	
	CopyArray(iniDijkstra(),rangedDijkstra())
	For x = *player\x-#rangedMax To *player\x+#rangedMax
		For y = *player\y-#rangedMax To *player\y+#rangedMax
			If x > 1 And x < xMax-1 And y > 1 And y < yMax-1 And (Abs(x-*player\x) > 1 Or Abs(y-*player\y) > 1)
				_Dist(*player\x,*player\y,x,y)
				If distance <= #rangedMax
					If bresenMap(x,y) And isNotBlocked(x,y,*player\x,*player\y)
						rangedDijkstra(x,y) = 1
					EndIf
				EndIf
			EndIf
		Next
	Next
	Repeat
		noChange = #True
		ForEach dijkstra()
			noChangeTemp = #True
			For dir = 1 To 8
				If collisionMap(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) >= #pathCollision
					Continue
				Else
					If rangedDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) < (rangedDijkstra(dijkstra()\x,dijkstra()\y) -10)
						rangedDijkstra(dijkstra()\x,dijkstra()\y) = rangedDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) +10
						noChange = #False
						noChangeTemp = #False
					EndIf
				EndIf
				
			Next
			If noChangeTemp And rangedDijkstra(dijkstra()\x,dijkstra()\y) <> highDijkstra
				DeleteElement(dijkstra())
			EndIf
		Next
	Until noChange
	

	CopyList(tempDijkstra(),dijkstra())
	CopyArray(playerDijkstra(),fleePlayerDijkstra())
	ForEach dijkstra()
		If *player\x = dijkstra()\x And *player\y = dijkstra()\y
			DeleteElement(dijkstra())
			Continue
		EndIf
		fleePlayerDijkstra(dijkstra()\x,dijkstra()\y) = (playerDijkstra(dijkstra()\x,dijkstra()\y)*(-12))/10
	Next
	Repeat
		noChange = #True
		ForEach dijkstra()
			noChangeTemp = #True
			For dir = 1 To 8
				If collisionMap(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) >= #pathCollision
					Continue
				Else
					If fleePlayerDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) < (fleePlayerDijkstra(dijkstra()\x,dijkstra()\y) -10)
						fleePlayerDijkstra(dijkstra()\x,dijkstra()\y) = fleePlayerDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) +10
						noChange = #False
						noChangeTemp = #False
					EndIf
				EndIf
				
			Next
			If noChangeTemp And fleePlayerDijkstra(dijkstra()\x,dijkstra()\y) <> highDijkstra
				DeleteElement(dijkstra())
			EndIf
		Next
	Until noChange	
	
	
;	EnableDebugger
EndProcedure


Procedure createGatherDijkstra()
	Define noChange
	Define noChange
	Define dir
	Define count
	Define *origin.ACTOR
	Define eachCount
	
	ClearList(pickTile())
	CopyList(finalDijkstra(),dijkstra())	
	CopyArray(iniDijkstra(),gatherDijkstra())
	_EachActor(#isMonsterP,0)
		*origin = @actor()
		If _MonCon(#monGather)
			AddElement(pickTile())
			pickTile()\x = *origin\x
			pickTile()\y = *origin\y
			count +1
		EndIf
	_EndEach()
	
	While ListSize(pickTile()) > (count*40)/100
		SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
		gatherDijkstra(pickTile()\x,pickTile()\y) = 1
		DeleteElement(pickTile())
	Wend
	
	Repeat
		noChange = #True
		ForEach dijkstra()
			For dir = 1 To 8
				If collisionMap(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) >= #pathCollision
					Continue
				Else
					If gatherDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) < (gatherDijkstra(dijkstra()\x,dijkstra()\y) -10)
						gatherDijkstra(dijkstra()\x,dijkstra()\y) = gatherDijkstra(dijkstra()\x+xMod(dir),dijkstra()\y+yMod(dir)) +10
						noChange = #False
					EndIf
				EndIf
				
			Next
		Next
	Until noChange
EndProcedure



Procedure lineEquation(x0,y0,x1,y1,stepSize)
	Protected x, y
	Protected num.f, denom.f, result.f
	
	ClearList(projectile())
	If x0 >= x1
		Swap x0, x1
		Swap y0, y1
	EndIf
	
	If Abs(x0-x1) >= Abs(y0-y1)
		For x = x0 To x1
			num = y1-y0
			denom = x1-x0
			result = ((num/denom) * (x-x0)) + y0
			AddElement(projectile())
			projectile()\x = x
			projectile()\y = result
			x + stepSize
		Next
	Else
		If y0 <= y1
			For y = y0 To y1
				num = x1-x0
				denom = y1-y0
				result = ((num/denom) * (y-y0)) + x0
				AddElement(projectile())
				projectile()\x = result
				projectile()\y = y
				y + stepSize
			Next
		Else
			For y = y1 To y0				
				num = x1-x0
				denom = y1-y0
				result = ((num/denom) * (y-y0)) + x0
				AddElement(projectile())
				projectile()\x = result
				projectile()\y = y
				y + stepSize
			Next
		EndIf		
	EndIf
EndProcedure


Procedure bellCurveRoll(min,max)
	Define value = max-min
	Define modValue = Mod(value,2)
	Define dice
	
	value/2
	dice = Random(value)+Random(value+modValue)+min
	
	ProcedureReturn dice
EndProcedure


Procedure wellCurveRoll(min,max)
	Define lowMedian, highMedian	
	Define absLow, absHigh
	Define minusDice = 0
	Define plusDice = 1
	Dim dice(1)

	
	lowMedian = Round((max+min)/2,#PB_Round_Down)
	highMedian = Round((max+min)/2,#PB_Round_Up)
	
	dice(minusDice) = Random(lowMedian,min)
	dice(plusDice) = Random(max,highMedian)
	absLow = Abs(dice(minusDice)-lowMedian)
	absHigh = Abs(dice(plusDice)-highMedian)
	
	If absLow = absHigh
		ProcedureReturn dice(Random(plusDice,minusDice))
	EndIf
	If absLow > absHigh
		ProcedureReturn dice(minusDice)
	EndIf
	If absHigh > absLow
		ProcedureReturn dice(plusDice)
	EndIf
EndProcedure


Procedure isAdjacent(x,y,xTarget,yTarget)
	If Abs(x-xTarget) < 2 And Abs(y-yTarget) < 2 And (x <> xTarget Or y <> yTarget)
		ProcedureReturn #True
	EndIf
EndProcedure


Procedure debugActor()
	If *debug = #Null
		ProcedureReturn #False
	EndIf

	ChangeCurrentElement(actor(),*debug)
	Debug ""
	Debug "Type: "+actor()\type+","+actor()\subtype+","+actor()\class+" ("+monsterConst(actor()\subtype,actor()\class,#monFaction)+")"
	Debug "Index: "+actor()\index+" ("+actor()\x+","+actor()\y+")"
	Debug "Hp: "+actor()\hp
	Debug "CanSee: "+canSee(actor()\x,actor()\y,*player\x,*player\y,actor()\vision)
	Debug "IsNotBlocked: "+isNotBlocked(actor()\x,actor()\y,*player\x,*player\y)
	Debug "Idle: "+ actor()\IDLE
	Debug "Flee: "+ actor()\FLEE
	Debug "Search: "+ actor()\SEARCH+" ("+actor()\xSearch+","+actor()\ySearch+")"+"   Counter:"+actor()\searchCounter
	Debug "CollisionMap: "+collisionMap(actor()\x,actor()\y)
	Debug "MotorSkill: "+actor()\motorSkill
	Debug "In Combat: "+actor()\inCombat
EndProcedure
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 282
; FirstLine = 276
; Folding = ----
; EnableXP